

def processBeginStatement(isHandler, match, currentStack, list) {
	def info = [:]
	
	def displayName = match[0][1]
	if (isHandler) {
		displayName = "Handler: " + displayName
	} else {
		displayName = "Event: " + displayName
	}
	//	 we need to have both a display name and a unique identifier
	info['name'] = displayName
	info['id'] = match[0][2]
	if (currentStack) {
		// we are a child
		if (currentStack[-1]['children'] == null) {
			currentStack[-1]['children'] = []
		}
		currentStack[-1]['children'] << info
	} else {
		list << info
	}
	
	currentStack << info
}

def processData(label, match, currentStack, counter) {
	// don't need to be on the stack since it can never have children
	def info = [:]
	info['name'] = label + match[0][1]
	info['id'] = counter.toString()
	counter++;
	if (currentStack[-1]['children'] == null) {
			currentStack[-1]['children'] = []
		}
	currentStack[-1]['children'] << info
	return counter;
}

def processEndStatement(currentStack) {
	currentStack.pop()
}

def onList() {
	def currentCookie = zget(zero.core.context.GlobalContextURIs.Request.Cookies.in + "#zeroDebugSessionId/0");
def eventlist = []
if (currentCookie != null) {
		def timestamp = request.params.timestamp[]
		def metaFileName = timestamp + "-meta.txt"
		def counter = 0
		def sessionDir = new File(config.root[], "logs/" + currentCookie.getValue())
		def metaFile = new File(sessionDir, metaFileName)
		def currentStack = []
		metaFile.eachLine { line ->
		def matchesBeginEvent = (line =~ /begin event displayName: (.+) id: (.+)/)
		def matchesEndEvent = (line =~ /end event (.+)/)
		def matchesBeginHandler = (line =~ /begin handler displayName: (.+) id: (.+)/)
		def matchesEndHandler = (line =~ /end handler (.+)/)
		def matchesCondData = (line =~ /condition data: (.+)/)
		def matchesInstanceData = (line =~ /instance data: (.+)/)
		def matchesEventData = (line =~ /event data: (.+)/)
		if (matchesBeginEvent) {
			processBeginStatement(false, matchesBeginEvent, currentStack, eventlist)
		} else if (matchesEndEvent) {
			processEndStatement(currentStack)
		} else if (matchesBeginHandler) {
			processBeginStatement(true, matchesBeginHandler, currentStack, eventlist)
		} else if (matchesEndHandler) {
			processEndStatement(currentStack)
		} else if (matchesCondData) {
			counter = processData("Condition Data: ", matchesCondData, currentStack, counter)
		} else if (matchesInstanceData) {
			counter = processData("Instance Data: " , matchesInstanceData, currentStack, counter)
		} else if (matchesEventData) {
			counter = processData("Event Data: ", matchesEventData, currentStack, counter)
		}
		}
	}

	def data = ['identifier': 'id', 'label': 'name', 'items' : eventlist]
	request.view = 'JSON'
	request.json.output = data
	render()
}